#ifndef __COLLECT_H
#define __COLLECT_H

class TCollection
{
  public:
    TCollection(unsigned, unsigned, void (*)(void*));
    TCollection();
    ~TCollection();
    void init(unsigned = 0, unsigned = 5, void (*)(void*) = 0);
    void done(void);
    void *at(unsigned);
    unsigned insert(void*);
    void removeAll(void);
    unsigned remove(unsigned);
    virtual void setLimit(unsigned);
    unsigned getCount() { return count; }
    void *find(int (*)(void*, void*), void*);
    int findIndex(int (*)(void*, void*), void*);
  private:
    void **items;
    unsigned count, limit, delta;
    void (*delItem)(void*);
};

struct TEInfo
{
  int ID, lang;
  TEInfo() { ID = lang = -1; }
  TEInfo(int aID, int aLang) { ID = aID; lang = aLang; }
};

class TEICollection: public TCollection
{
  public:
    TEICollection(unsigned = 0, unsigned = 5);
    unsigned insert(int, int);
    unsigned removeID(int);
    int findID(int);
    int findLang(int);
};
#endif
